/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "parser.y"

/*
 * Copyright 2013 Google Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
/*
 * Author: Author: ncardwell@google.com (Neal Cardwell)
 *
 * This is the parser for the packetdrill script language. It is
 * processed by the bison parser generator.
 *
 * For full documentation see: http://www.gnu.org/software/bison/manual/
 *
 * Here is a quick and dirty tutorial on bison:
 *
 * A bison parser specification is basically a BNF grammar for the
 * language you are parsing. Each rule specifies a nonterminal symbol
 * on the left-hand side and a sequence of terminal symbols (lexical
 * tokens) and or nonterminal symbols on the right-hand side that can
 * "reduce" to the symbol on the left hand side. When the parser sees
 * the sequence of symbols on the right where it "wants" to see a
 * nonterminal on the left, the rule fires, executing the semantic
 * action code in curly {} braces as it reduces the right hand side to
 * the left hand side.
 *
 * The semantic action code for a rule produces an output, which it
 * can reference using the $$ token. The set of possible types
 * returned in output expressions is given in the %union section of
 * the .y file. The specific type of the output for a terminal or
 * nonterminal symbol (corresponding to a field in the %union) is
 * given by the %type directive in the .y file. The action code can
 * access the outputs of the symbols on the right hand side by using
 * the notation $1 for the first symbol, $2 for the second symbol, and
 * so on.
 *
 * The lexer (generated by flex from lexer.l) feeds a stream of
 * terminal symbols up to this parser. Parser semantic actions can
 * access the lexer output for a terminal symbol with the same
 * notation they use for nonterminals.
 *
 * Here's an example rule with its semantic action in {} braces:
 *
 *     tcp_option
 *     ...
 *      | MSS INTEGER   {
 *        $$ = tcp_option_new(...);
 *        ...
 *        $$->data.mss.bytes = htons($2);
 *      }
 *
 * This rule basically says:
 *
 *   When the parser wants to see a tcp_option, if it sees an MSS from
 *   the lexer followed by an INTEGER from the lexer then run the
 *   action code that (a) stores in the output $$ a pointer to a
 *   struct tcp_option object, and then (b) stores in that object the
 *   value of the INTEGER token (accessed with $2).
 *
 */

/* The first part of the .y file consists of C code that bison copies
 * directly into the top of the .c file it generates.
 */

#include "types.h"

#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "gre_packet.h"
#include "ip.h"
#include "ip_packet.h"
#include "icmp_packet.h"
#include "logging.h"
#include "mpls.h"
#include "mpls_packet.h"
#include "tcp_packet.h"
#include "udp_packet.h"
#include "parse.h"
#include "script.h"
#include "tcp.h"
#include "tcp_options.h"

/* This include of the bison-generated .h file must go last so that we
 * can first include all of the declarations on which it depends.
 */
#include "parser.h"

/* Change this YYDEBUG to 1 to get verbose debug output for parsing: */
#define YYDEBUG 0
#if YYDEBUG
extern int yydebug;
#endif

extern FILE *yyin;
extern int yylineno;
extern char *yytext;
extern int yylex(void);
extern int yyparse(void);
extern int yywrap(void);

/* This mutex guards all parser global variables declared in this file. */
pthread_mutex_t parser_mutex = PTHREAD_MUTEX_INITIALIZER;

/* The input to the parser: the path name of the script file to parse. */
static const char* current_script_path = NULL;

/* The starting line number of the input script statement that we're
 * currently parsing. This may be different than yylineno if bison had
 * to look ahead and lexically scan a token on the following line to
 * decide that the current statement is done.
 */
static int current_script_line = -1;

/*
 * We uses this object to look up configuration info needed during
 * parsing (such as whether packets are IPv4 or IPv6).
 */
static const struct config *in_config = NULL;

/* The output of the parser: an output script containing
 * 1) a linked list of options
 * 2) a linked list of events
 */
static struct script *out_script = NULL;

/* The test invocation to pass back to parse_and_finalize_config(). */
struct invocation *invocation;

/* Copy the script contents into our single linear buffer. */
void copy_script(const char *script_buffer, struct script *script)
{
	DEBUGP("copy_script\n");

	free(script->buffer);
	script->length = strlen(script_buffer);
	script->buffer = strdup(script_buffer);
	assert(script->buffer != NULL);

	DEBUGP("copy_script: %d bytes\n", script->length);
}

/* Read the script file into a single linear buffer. */
void read_script(const char *script_path, struct script *script)
{
	int size = 0;

	DEBUGP("read_script(%s)\n", script_path);

	while (script->buffer == NULL) {
		struct stat script_info;
		int fd = -1;

		/* Allocate a buffer big enough for the whole file. */
		if (stat(script_path, &script_info) != 0)
			die("parse error: stat() of script file '%s': %s\n",
			    script_path, strerror(errno));

		/* Pick a buffer size larger than the file, so we'll
		 * know if the file grew.
		 */
		size = max((int)script_info.st_size, size) + 1;

		script->buffer = malloc(size);
		assert(script->buffer != NULL);

		/* Read the file into our buffer. */
		fd = open(script_path, O_RDONLY);
		if (fd < 0)
			die("parse error opening script file '%s': %s\n",
			    script_path, strerror(errno));

		script->length = read(fd, script->buffer, size);
		if (script->length < 0)
			die("parse error reading script file '%s': %s\n",
			    script_path, strerror(errno));

		/* If we filled the buffer, then probably another
		 * process wrote more to the file since our stat call,
		 * so we should try again.
		 */
		if (script->length == size) {
			free(script->buffer);
			script->buffer = NULL;
			script->length = 0;
		}

		if (close(fd))
			die_perror("close");
	}
	DEBUGP("read_script: %d bytes\n", script->length);
}


/* The public entry point for the script parser. Parses the
 * text script file with the given path name and fills in the script
 * object with the parsed representation.
 */
int parse_script(const struct config *config,
			 struct script *script,
			 struct invocation *callback_invocation)
{
	/* This bison-generated parser is not multi-thread safe, so we
	 * have a lock to prevent more than one thread using the
	 * parser at the same time. This is useful in the wire server
	 * context, where in general we may have more than one test
	 * thread running at the same time.
	 */
	if (pthread_mutex_lock(&parser_mutex) != 0)
		die_perror("pthread_mutex_lock");

#if YYDEBUG
	yydebug = 1;
#endif

	/* Now parse the script from our buffer. */
	yyin = fmemopen(script->buffer, script->length, "r");
	if (yyin == NULL)
		die_perror("fmemopen: parse error opening script buffer");

	current_script_path = config->script_path;
	in_config = config;
	out_script = script;
	invocation = callback_invocation;

	/* We have to reset the line number here since the wire server
	 * can do more than one yyparse().
	 */
	yylineno = 1;

	int result = yyparse();		/* invoke bison-generated parser */
	current_script_path = NULL;

	if (fclose(yyin))
		die_perror("fclose: error closing script buffer");

	/* Unlock parser. */
	if (pthread_mutex_unlock(&parser_mutex) != 0)
		die_perror("pthread_mutex_unlock");

	return result ? STATUS_ERR : STATUS_OK;
}

/* Bison emits code to call this method when there's a parse-time error.
 * We print the line number and the error message.
 */
static void yyerror(const char *message)
{
	fprintf(stderr, "%s:%d: parse error at '%s': %s\n",
		current_script_path, yylineno, yytext, message);
}

/* After we finish parsing each line of a script, we analyze the
 * semantics of the line. If we encounter an error then we print the
 * error message to stderr and exit with an error.
 */
static void semantic_error(const char* message)
{
	assert(current_script_line >= 0);
	die("%s:%d: semantic error: %s\n",
	    current_script_path, current_script_line, message);
}

/* This standard callback is invoked by flex when it encounters
 * the end of a file. We return 1 to tell flex to return EOF.
 */
int yywrap(void)
{
	return 1;
}

/* Create and initalize a new expression. */
static struct expression *new_expression(enum expression_t type)
{
	struct expression *expression = calloc(1, sizeof(struct expression));
	expression->type = type;
	return expression;
}

/* Create and initalize a new integer expression with the given
 * literal value and format string.
 */
static struct expression *new_integer_expression(s64 num, const char *format)
{
	struct expression *expression = new_expression(EXPR_INTEGER);
	expression->value.num = num;
	expression->format = format;
	return expression;
}

/* Create and initalize a new one-element expression_list. */
static struct expression_list *new_expression_list(
	struct expression *expression)
{
	struct expression_list *list;
	list = calloc(1, sizeof(struct expression_list));
	list->expression = expression;
	list->next = NULL;
	return list;
}

/* Add the expression to the end of the list. */
static void expression_list_append(struct expression_list *list,
				   struct expression *expression)
{
	while (list->next != NULL) {
		list = list->next;
	}
	list->next = new_expression_list(expression);
}

/* Create and initialize a new option. */
static struct option_list *new_option(char *name, char *value)
{
	struct option_list *opt = calloc(1, sizeof(struct option_list));
	opt->name = name;
	opt->value = value;
	return opt;
}

/* Create and initialize a new event. */
static struct event *new_event(enum event_t type)
{
	struct event *e = calloc(1, sizeof(struct event));
	e->type = type;
	e->time_usecs_end = NO_TIME_RANGE;
	e->offset_usecs = NO_TIME_RANGE;
	return e;
}

static int parse_hex_byte(const char *hex, u8 *byte)
{
	if (!isxdigit((int)hex[0]) || !isxdigit((int)hex[1])) {
		return STATUS_ERR;	/* need two hex digits per byte */
	}
	char buf[] = { hex[0], hex[1], '\0' };
	char* buf_end = NULL;
	u32 byte_value = strtoul(buf, &buf_end, 16);
	assert(byte_value <= 0xff);
	assert(buf_end == buf + 2);
	*byte = byte_value;
	return STATUS_OK;
}

/* Converts a hex string in 'hex' into bytes and stores them in a
 * buffer 'buf' of length 'buf_len' bytes; returns number of bytes in
 * out_len. Works for hex strings of arbitrary size, such as very long
 * TCP Fast Open cookies.
 */
static int parse_hex_string(const char *hex, u8 *buf, int buf_len,
			    int *out_len)
{
	u8 *out = buf;
	u8 *buf_end = buf + buf_len;
	while (hex[0] != '\0') {
		if (out >= buf_end) {
			return STATUS_ERR;	/* ran out of output space */
		}
		if (parse_hex_byte(hex, out))
			return STATUS_ERR;	/* bad character */
		hex += 2;
		out += 1;
	}
	*out_len = out - buf;
	assert(*out_len <= buf_len);
	return STATUS_OK;
}

static struct tcp_option *new_tcp_fast_open_option(const char *cookie_string,
						    char **error)
{
	int cookie_string_len = strlen(cookie_string);
	if (cookie_string_len & 1) {
		asprintf(error,
			 "TCP fast open cookie has an odd number of digits");
		return NULL;
	}
	int cookie_bytes = cookie_string_len / 2;  /* 2 hex chars per byte */
	if (cookie_bytes > MAX_TCP_FAST_OPEN_COOKIE_BYTES) {
		asprintf(error, "TCP fast open cookie too long");
		asprintf(error, "TCP fast open cookie of %d bytes "
			 "exceeds maximum cookie length of %d bytes",
			 cookie_bytes, MAX_TCP_FAST_OPEN_COOKIE_BYTES);
		return NULL;
	}
	u8 option_bytes = TCPOLEN_EXP_FASTOPEN_BASE + cookie_bytes;
	struct tcp_option *option;
	option = tcp_option_new(TCPOPT_EXP, option_bytes);
	option->data.fast_open.magic = htons(TCPOPT_FASTOPEN_MAGIC);
	int parsed_bytes = 0;
	/* Parse cookie. This should be an ASCII hex string
	 * representing an even number of bytes (4-16 bytes). But we
	 * do not enforce this, since we want to allow test cases that
	 * supply invalid cookies.
	 */
	if (parse_hex_string(cookie_string, option->data.fast_open.cookie,
			     sizeof(option->data.fast_open.cookie),
			     &parsed_bytes)) {
		free(option);
		asprintf(error,
			 "TCP fast open cookie is not a valid hex string");
		return NULL;
	}
	assert(parsed_bytes == cookie_bytes);
	return option;
}


/* Line 371 of yacc.c  */
#line 500 "parser.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ELLIPSIS = 258,
     SA_FAMILY = 259,
     SIN_PORT = 260,
     SIN_ADDR = 261,
     _HTONS_ = 262,
     INET_ADDR = 263,
     MSG_NAME = 264,
     MSG_IOV = 265,
     MSG_FLAGS = 266,
     FD = 267,
     EVENTS = 268,
     REVENTS = 269,
     ONOFF = 270,
     LINGER = 271,
     ACK = 272,
     ECR = 273,
     EOL = 274,
     MSS = 275,
     NOP = 276,
     SACK = 277,
     SACKOK = 278,
     TIMESTAMP = 279,
     VAL = 280,
     WIN = 281,
     WSCALE = 282,
     PRO = 283,
     FAST_OPEN = 284,
     ECT0 = 285,
     ECT1 = 286,
     CE = 287,
     ECT01 = 288,
     NO_ECN = 289,
     IPV4 = 290,
     IPV6 = 291,
     ICMP = 292,
     UDP = 293,
     GRE = 294,
     MTU = 295,
     MPLS = 296,
     LABEL = 297,
     TC = 298,
     TTL = 299,
     OPTION = 300,
     FLOAT = 301,
     INTEGER = 302,
     HEX_INTEGER = 303,
     WORD = 304,
     STRING = 305,
     BACK_QUOTED = 306,
     CODE = 307,
     IPV4_ADDR = 308,
     IPV6_ADDR = 309
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 438 "parser.y"

	s64 integer;
	double floating;
	char *string;
	char *reserved;
	s64 time_usecs;
	enum direction_t direction;
	enum ip_ecn_t ip_ecn;
	struct mpls_stack *mpls_stack;
	struct mpls mpls_stack_entry;
	u16 port;
	s32 window;
	u32 sequence_number;
	struct {
		int protocol;		/* IPPROTO_TCP or IPPROTO_UDP */
		u32 start_sequence;
		u16 payload_bytes;
	} tcp_sequence_info;
	struct option_list *option;
	struct event *event;
	struct packet *packet;
	struct syscall_spec *syscall;
	struct command_spec *command;
	struct code_spec *code;
	struct tcp_option *tcp_option;
	struct tcp_options *tcp_options;
	struct expression *expression;
	struct expression_list *expression_list;
	struct errno_spec *errno_info;


/* Line 387 of yacc.c  */
#line 629 "parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;
extern YYLTYPE yylloc;
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 670 "parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   255

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  63
/* YYNRULES -- Number of rules.  */
#define YYNRULES  138
/* YYNRULES -- Number of states.  */
#define YYNSTATES  274

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   309

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      59,    60,    57,    56,    63,    68,    67,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      66,    55,    61,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    64,     2,    65,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,    69,    71,    58,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,     8,    10,    12,    15,    19,    21,
      23,    25,    27,    29,    31,    33,    35,    36,    38,    40,
      42,    45,    48,    51,    53,    55,    59,    65,    67,    69,
      71,    73,    75,    77,    79,    81,    83,    91,    97,   104,
     106,   113,   120,   124,   129,   130,   133,   145,   146,   151,
     153,   154,   156,   157,   164,   168,   169,   172,   174,   176,
     177,   181,   183,   185,   187,   189,   191,   193,   195,   198,
     200,   207,   208,   211,   212,   215,   216,   220,   224,   226,
     230,   231,   233,   235,   237,   239,   241,   244,   247,   249,
     252,   258,   261,   263,   266,   270,   278,   279,   282,   284,
     287,   291,   293,   297,   299,   301,   303,   305,   307,   310,
     312,   314,   316,   318,   320,   322,   324,   326,   328,   330,
     334,   337,   341,   346,   366,   386,   392,   403,   404,   409,
     419,   420,   423,   424,   426,   430,   432,   435,   437
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      73,     0,    -1,    74,    79,    81,    -1,    -1,    75,    -1,
      76,    -1,    75,    76,    -1,    77,    55,    78,    -1,    45,
      -1,    47,    -1,    49,    -1,    50,    -1,    53,    -1,    54,
      -1,    35,    -1,    36,    -1,    -1,    80,    -1,   133,    -1,
      82,    -1,    81,    82,    -1,    83,    85,    -1,    56,    84,
      -1,    84,    -1,    57,    -1,    84,    58,    84,    -1,    56,
      84,    58,    56,    84,    -1,    46,    -1,    47,    -1,    86,
      -1,   112,    -1,   133,    -1,   134,    -1,    87,    -1,    88,
      -1,    89,    -1,    90,    99,   101,   102,   103,   104,   105,
      -1,    90,    38,    59,    47,    60,    -1,    90,    96,    37,
      94,    95,    97,    -1,    98,    -1,    90,    35,    53,    61,
      53,    62,    -1,    90,    36,    54,    61,    54,    62,    -1,
      90,    39,    62,    -1,    90,    41,    91,    62,    -1,    -1,
      91,    92,    -1,    59,    42,    47,    63,    43,    47,    63,
      93,    44,    47,    60,    -1,    -1,    64,    49,    65,    63,
      -1,    49,    -1,    -1,    49,    -1,    -1,    64,    38,    59,
      47,    60,    65,    -1,    64,   102,    65,    -1,    -1,    40,
      47,    -1,    66,    -1,    61,    -1,    -1,    64,   100,    65,
      -1,    34,    -1,    30,    -1,    31,    -1,    33,    -1,    32,
      -1,    49,    -1,    67,    -1,    49,    67,    -1,    68,    -1,
      47,    62,    47,    59,    47,    60,    -1,    -1,    17,    47,
      -1,    -1,    26,    47,    -1,    -1,    66,   106,    61,    -1,
      66,     3,    61,    -1,   109,    -1,   106,    63,   109,    -1,
      -1,   108,    -1,    49,    -1,    47,    -1,    21,    -1,    19,
      -1,    20,    47,    -1,    27,    47,    -1,    23,    -1,    22,
     110,    -1,    24,    25,    47,    18,    47,    -1,    29,   107,
      -1,   111,    -1,   110,   111,    -1,    47,    62,    47,    -1,
     113,   114,   115,    55,   117,   129,   130,    -1,    -1,     3,
      84,    -1,    49,    -1,    59,    60,    -1,    59,   116,    60,
      -1,   117,    -1,   116,    63,   117,    -1,     3,    -1,   118,
      -1,   119,    -1,    49,    -1,    50,    -1,    50,     3,    -1,
     120,    -1,   121,    -1,   122,    -1,   123,    -1,   124,    -1,
     125,    -1,   126,    -1,   128,    -1,    47,    -1,    48,    -1,
     117,    69,   117,    -1,    64,    65,    -1,    64,   116,    65,
      -1,     8,    59,    50,    60,    -1,    70,     4,    55,    49,
      63,     5,    55,     7,    59,    47,    60,    63,     6,    55,
       8,    59,    50,    60,    71,    -1,    70,     9,    59,     3,
      60,    55,     3,    63,    10,    59,   118,    60,    55,   121,
      63,    11,    55,   117,    71,    -1,    70,     3,    63,   118,
      71,    -1,    70,    12,    55,   117,    63,    13,    55,   117,
     127,    71,    -1,    -1,    63,    14,    55,   117,    -1,    70,
      15,    55,    47,    63,    16,    55,    47,    71,    -1,    -1,
      49,   131,    -1,    -1,   131,    -1,    59,   132,    60,    -1,
      49,    -1,   132,    49,    -1,    51,    -1,    52,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   520,   520,   526,   530,   537,   541,   548,   553,   557,
     558,   559,   560,   561,   562,   563,   567,   568,   572,   576,
     581,   588,   617,   623,   629,   634,   641,   651,   657,   666,
     667,   668,   669,   673,   674,   675,   679,   707,   728,   749,
     753,   764,   775,   782,   795,   798,   807,   823,   824,   833,
     837,   838,   843,   848,   853,   859,   860,   864,   865,   869,
     870,   874,   875,   876,   877,   878,   882,   883,   884,   885,
     889,   910,   911,   920,   921,   930,   931,   932,   936,   942,
     951,   952,   956,   957,   961,   962,   963,   970,   977,   981,
     984,   998,  1011,  1012,  1027,  1041,  1054,  1055,  1059,  1063,
    1064,  1068,  1069,  1073,  1076,  1077,  1078,  1082,  1087,  1092,
    1095,  1098,  1101,  1104,  1107,  1110,  1113,  1119,  1125,  1131,
    1143,  1147,  1154,  1161,  1193,  1209,  1219,  1230,  1231,  1235,
    1243,  1244,  1252,  1253,  1257,  1261,  1262,  1266,  1274
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ELLIPSIS", "SA_FAMILY", "SIN_PORT",
  "SIN_ADDR", "_HTONS_", "INET_ADDR", "MSG_NAME", "MSG_IOV", "MSG_FLAGS",
  "FD", "EVENTS", "REVENTS", "ONOFF", "LINGER", "ACK", "ECR", "EOL", "MSS",
  "NOP", "SACK", "SACKOK", "TIMESTAMP", "VAL", "WIN", "WSCALE", "PRO",
  "FAST_OPEN", "ECT0", "ECT1", "CE", "ECT01", "NO_ECN", "IPV4", "IPV6",
  "ICMP", "UDP", "GRE", "MTU", "MPLS", "LABEL", "TC", "TTL", "OPTION",
  "FLOAT", "INTEGER", "HEX_INTEGER", "WORD", "STRING", "BACK_QUOTED",
  "CODE", "IPV4_ADDR", "IPV6_ADDR", "'='", "'+'", "'*'", "'~'", "'('",
  "')'", "'>'", "':'", "','", "'['", "']'", "'<'", "'.'", "'-'", "'|'",
  "'{'", "'}'", "$accept", "script", "opt_options", "options", "option",
  "option_flag", "option_value", "opt_init_command", "init_command",
  "events", "event", "event_time", "time", "action", "packet_spec",
  "tcp_packet_spec", "udp_packet_spec", "icmp_packet_spec",
  "packet_prefix", "mpls_stack", "mpls_stack_entry",
  "opt_mpls_stack_bottom", "icmp_type", "opt_icmp_code", "opt_icmp_echoed",
  "opt_icmp_mtu", "direction", "opt_ip_info", "ip_ecn", "flags", "seq",
  "opt_ack", "opt_window", "opt_tcp_options", "tcp_option_list",
  "opt_tcp_fast_open_cookie", "tcp_fast_open_cookie", "tcp_option",
  "sack_block_list", "sack_block", "syscall_spec", "opt_end_time",
  "function_name", "function_arguments", "expression_list", "expression",
  "decimal_integer", "hex_integer", "binary_expression", "array", "inaddr",
  "sockaddr", "msghdr", "iovec", "pollfd", "opt_revents", "linger",
  "opt_errno", "opt_note", "note", "word_list", "command_spec",
  "code_spec", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    61,    43,    42,   126,    40,
      41,    62,    58,    44,    91,    93,    60,    46,    45,   124,
     123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    72,    73,    74,    74,    75,    75,    76,    77,    78,
      78,    78,    78,    78,    78,    78,    79,    79,    80,    81,
      81,    82,    83,    83,    83,    83,    83,    84,    84,    85,
      85,    85,    85,    86,    86,    86,    87,    88,    89,    90,
      90,    90,    90,    90,    91,    91,    92,    93,    93,    94,
      95,    95,    96,    96,    96,    97,    97,    98,    98,    99,
      99,   100,   100,   100,   100,   100,   101,   101,   101,   101,
     102,   103,   103,   104,   104,   105,   105,   105,   106,   106,
     107,   107,   108,   108,   109,   109,   109,   109,   109,   109,
     109,   109,   110,   110,   111,   112,   113,   113,   114,   115,
     115,   116,   116,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   118,   119,   120,
     121,   121,   122,   123,   124,   125,   126,   127,   127,   128,
     129,   129,   130,   130,   131,   132,   132,   133,   134
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     1,     1,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       2,     2,     2,     1,     1,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     5,     6,     1,
       6,     6,     3,     4,     0,     2,    11,     0,     4,     1,
       0,     1,     0,     6,     3,     0,     2,     1,     1,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       6,     0,     2,     0,     2,     0,     3,     3,     1,     3,
       0,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       5,     2,     1,     2,     3,     7,     0,     2,     1,     2,
       3,     1,     3,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       2,     3,     4,    19,    19,     5,    10,     0,     4,     9,
       0,     2,     0,     1,     3,     1,     2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     8,     0,    16,     4,     5,     0,     1,   137,     0,
      17,    18,     6,     0,    27,    28,     0,    24,     2,    19,
      96,    23,    14,    15,     9,    10,    11,    12,    13,     7,
      22,    20,     0,   138,    58,    57,    21,    29,    33,    34,
      35,    59,    39,    30,     0,    31,    32,     0,     0,    97,
       0,     0,     0,     0,    44,     0,     0,     0,    98,     0,
      25,     0,     0,     0,     0,    42,     0,    62,    63,    65,
      64,    61,     0,     0,     0,     0,     0,    66,    67,    69,
       0,     0,     0,    26,     0,     0,     0,     0,    43,    45,
       0,     0,    60,    54,    49,    50,    68,    71,   103,     0,
     117,   118,   106,   107,    99,     0,     0,     0,   101,   104,
     105,   109,   110,   111,   112,   113,   114,   115,   116,     0,
       0,     0,    37,     0,     0,     0,    51,    55,     0,    73,
       0,   108,   120,     0,     0,     0,     0,     0,     0,   100,
       0,     0,   130,    40,    41,     0,     0,     0,     0,    38,
      72,     0,    75,     0,   121,     0,     0,     0,     0,     0,
     102,   119,     0,   132,     0,    53,     0,    56,    74,     0,
      36,   122,     0,     0,     0,     0,     0,     0,   131,    95,
     133,     0,    70,     0,    85,     0,    84,     0,    88,     0,
       0,    80,     0,    78,   125,     0,     0,     0,     0,   135,
       0,     0,    77,    86,     0,    89,    92,     0,    87,    83,
      82,    91,    81,    76,     0,     0,     0,     0,     0,   136,
     134,    47,     0,    93,     0,    79,     0,     0,     0,     0,
       0,     0,    94,     0,     0,     0,   127,     0,     0,     0,
      90,     0,     0,     0,     0,   129,     0,     0,     0,     0,
       0,   126,    48,    46,     0,     0,     0,     0,     0,   128,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   123,   124
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,     5,     6,    29,     9,    10,    18,
      19,    20,    21,    36,    37,    38,    39,    40,    41,    66,
      89,   231,    95,   127,    56,   149,    42,    57,    74,    80,
      75,   129,   152,   170,   192,   211,   212,   193,   205,   206,
      43,    44,    59,    82,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   244,   118,   163,   179,   178,
     200,    11,    46
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -155
static const yytype_int16 yypact[] =
{
     -36,  -155,     4,   -32,   -36,  -155,   -18,  -155,  -155,    67,
    -155,  -155,  -155,    50,  -155,  -155,    19,  -155,    67,  -155,
       9,   -13,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
      14,  -155,    19,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,    43,  -155,  -155,    34,  -155,  -155,    19,    31,  -155,
      40,    44,    35,    39,  -155,    58,    65,   -41,  -155,    53,
    -155,    19,    54,    56,    71,  -155,   -42,  -155,  -155,  -155,
    -155,  -155,    61,    59,    66,    69,    83,    72,  -155,  -155,
      89,    -1,    85,  -155,    88,    84,    82,   101,  -155,  -155,
      97,    98,  -155,  -155,  -155,    99,  -155,   129,  -155,    90,
    -155,  -155,  -155,   144,  -155,     3,   107,   -35,    86,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,     7,
      91,    92,  -155,   104,    96,    93,  -155,   117,   111,   133,
     110,  -155,  -155,   -22,   100,   109,   102,   112,   113,  -155,
       7,     7,   -46,  -155,  -155,   103,   105,   115,   118,  -155,
    -155,   122,   108,   116,  -155,   124,   123,   170,     7,   128,
      86,    86,   119,   119,   134,  -155,   120,  -155,  -155,    11,
    -155,  -155,   114,   121,   126,   -45,   125,   130,  -155,  -155,
    -155,   135,  -155,   131,  -155,   136,  -155,   140,  -155,   156,
     142,    15,    13,  -155,  -155,   185,   138,   178,   179,  -155,
     -44,   137,  -155,  -155,   132,   140,  -155,   149,  -155,  -155,
    -155,  -155,  -155,  -155,   106,   143,   194,   146,   147,  -155,
    -155,   139,   152,  -155,   186,  -155,   198,   145,     7,   159,
     158,   165,  -155,   163,   153,   201,   -27,   148,   150,   166,
    -155,   167,   157,   203,   151,  -155,   155,   160,   161,   124,
     168,  -155,  -155,  -155,   162,   164,     7,   220,   172,    86,
     173,   169,   221,   171,   176,   219,   181,   177,   180,     7,
     174,    37,  -155,  -155
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -155,  -155,  -155,  -155,   232,  -155,  -155,  -155,  -155,  -155,
     223,  -155,    -3,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
     175,  -155,  -155,  -155,  -155,  -155,  -155,    23,  -155,    33,
    -155,  -155,  -155,  -155,   141,  -119,  -154,  -155,  -155,   -19,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,    76,
    -155,   224,  -155
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -53
static const yytype_int16 yytable[] =
{
     142,   172,    98,   162,     7,   219,    98,    99,    77,     1,
      98,    99,    32,    30,   183,    99,   220,    87,   197,     8,
      88,   160,   161,   141,   141,   139,    78,    79,   140,    49,
     184,   185,   186,   187,   188,   189,   243,    13,   190,   175,
     191,   140,   141,   154,    60,    47,   100,   101,   102,   103,
     100,   101,   102,   103,   100,   101,   102,   103,    83,   104,
       8,    33,   209,   105,   210,    14,    15,   105,   132,   106,
      34,   105,    48,   106,   213,    35,   214,   106,    50,    51,
     -52,    52,    53,    58,    54,    22,    23,    61,    67,    68,
      69,    70,    71,    62,    64,   255,    72,    24,    63,    25,
      26,    65,    76,    27,    28,    73,   141,    55,   273,   236,
     134,   135,    81,    14,    15,    84,   136,    85,    86,   137,
      90,    91,   138,    16,    17,   184,   185,   186,   187,   188,
     189,    92,    94,   190,    93,   191,    73,   259,   121,    96,
     119,   120,   122,   123,   124,   125,   128,   131,   126,   130,
     271,   145,   147,   143,   144,   141,   146,   148,   150,   151,
     153,   157,   166,   155,   156,   167,   164,   158,   159,   168,
     165,   100,   173,   174,   169,   176,   171,   181,   177,   199,
     182,   207,   201,   203,   195,   194,   196,   204,   198,   208,
     215,   217,   202,   216,   222,   218,   224,   227,   226,   232,
     221,   228,   229,   230,   233,   234,   237,   238,   235,   239,
     240,   242,   241,   247,   248,   246,   249,   250,   252,   245,
     253,   254,   251,   256,   258,   257,   260,   261,   262,   264,
     267,   268,   269,   105,   265,   266,    12,   225,   223,   180,
     270,    31,   263,     0,    45,   272,   133,     0,     0,     0,
       0,     0,     0,     0,     0,    97
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-155)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
     119,   155,     3,    49,     0,    49,     3,     8,    49,    45,
       3,     8,     3,    16,     3,     8,    60,    59,    63,    51,
      62,   140,   141,    69,    69,    60,    67,    68,    63,    32,
      19,    20,    21,    22,    23,    24,    63,    55,    27,   158,
      29,    63,    69,    65,    47,    58,    47,    48,    49,    50,
      47,    48,    49,    50,    47,    48,    49,    50,    61,    60,
      51,    52,    47,    64,    49,    46,    47,    64,    65,    70,
      61,    64,    58,    70,    61,    66,    63,    70,    35,    36,
      37,    38,    39,    49,    41,    35,    36,    56,    30,    31,
      32,    33,    34,    53,    59,   249,    38,    47,    54,    49,
      50,    62,    37,    53,    54,    47,    69,    64,    71,   228,
       3,     4,    59,    46,    47,    61,     9,    61,    47,    12,
      59,    62,    15,    56,    57,    19,    20,    21,    22,    23,
      24,    65,    49,    27,    65,    29,    47,   256,    54,    67,
      55,    53,    60,    42,    47,    47,    17,     3,    49,    59,
     269,    47,    59,    62,    62,    69,    60,    40,    47,    26,
      50,    59,    47,    63,    55,    47,    63,    55,    55,    47,
      65,    47,    49,     3,    66,    47,    60,    43,    59,    49,
      60,    25,    47,    47,    63,    71,    60,    47,    63,    47,
       5,    13,    61,    55,    62,    16,    47,     3,    55,    47,
      63,    55,    55,    64,    18,     7,    47,    49,    63,    44,
      47,    10,    59,    47,    47,    65,    59,    14,    63,    71,
      60,    60,    71,    55,    60,    63,     6,    55,    55,     8,
      11,    50,    55,    64,    63,    59,     4,   214,   205,   163,
      60,    18,   261,    -1,    20,    71,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    45,    73,    74,    75,    76,    77,     0,    51,    79,
      80,   133,    76,    55,    46,    47,    56,    57,    81,    82,
      83,    84,    35,    36,    47,    49,    50,    53,    54,    78,
      84,    82,     3,    52,    61,    66,    85,    86,    87,    88,
      89,    90,    98,   112,   113,   133,   134,    58,    58,    84,
      35,    36,    38,    39,    41,    64,    96,    99,    49,   114,
      84,    56,    53,    54,    59,    62,    91,    30,    31,    32,
      33,    34,    38,    47,   100,   102,    37,    49,    67,    68,
     101,    59,   115,    84,    61,    61,    47,    59,    62,    92,
      59,    62,    65,    65,    49,    94,    67,   102,     3,     8,
      47,    48,    49,    50,    60,    64,    70,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   128,    55,
      53,    54,    60,    42,    47,    47,    49,    95,    17,   103,
      59,     3,    65,   116,     3,     4,     9,    12,    15,    60,
      63,    69,   117,    62,    62,    47,    60,    59,    40,    97,
      47,    26,   104,    50,    65,    63,    55,    59,    55,    55,
     117,   117,    49,   129,    63,    65,    47,    47,    47,    66,
     105,    60,   118,    49,     3,   117,    47,    59,   131,   130,
     131,    43,    60,     3,    19,    20,    21,    22,    23,    24,
      27,    29,   106,   109,    71,    63,    60,    63,    63,    49,
     132,    47,    61,    47,    47,   110,   111,    25,    47,    47,
      49,   107,   108,    61,    63,     5,    55,    13,    16,    49,
      60,    63,    62,   111,    47,   109,    55,     3,    55,    55,
      64,    93,    47,    18,     7,    63,   117,    47,    49,    44,
      47,    59,    10,    63,   127,    71,    65,    47,    47,    59,
      14,    71,    63,    60,    60,   118,    55,    63,    60,   117,
       6,    55,    55,   121,     8,    63,    59,    11,    50,    55,
      60,   117,    71,    71
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;


/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 520 "parser.y"
    {
	(yyval.string) = NULL;		/* The parser output is in out_script */
}
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 526 "parser.y"
    {
	(yyval.option) = NULL;
	parse_and_finalize_config(invocation);
}
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 530 "parser.y"
    {
	(yyval.option) = (yyvsp[(1) - (1)].option);
	parse_and_finalize_config(invocation);
}
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 537 "parser.y"
    {
	out_script->option_list = (yyvsp[(1) - (1)].option);
	(yyval.option) = (yyvsp[(1) - (1)].option);		/* return the tail so we can append to it */
}
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 541 "parser.y"
    {
	(yyvsp[(1) - (2)].option)->next = (yyvsp[(2) - (2)].option);
	(yyval.option) = (yyvsp[(2) - (2)].option);		/* return the tail so we can append to it */
}
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 548 "parser.y"
    {
	(yyval.option) = new_option((yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].string));
}
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 553 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].reserved); }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 557 "parser.y"
    { (yyval.string) = strdup(yytext); }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 558 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 559 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 560 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 561 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 562 "parser.y"
    { (yyval.string) = strdup("ipv4"); }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 563 "parser.y"
    { (yyval.string) = strdup("ipv6"); }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 567 "parser.y"
    { }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 568 "parser.y"
    { }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 572 "parser.y"
    { out_script->init_command = (yyvsp[(1) - (1)].command); }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 576 "parser.y"
    {
	out_script->event_list = (yyvsp[(1) - (1)].event);  /* save pointer to event list as output
				       * of parser */
	(yyval.event) = (yyvsp[(1) - (1)].event);          /* return the tail so that we can append to it */
}
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 581 "parser.y"
    {
	(yyvsp[(1) - (2)].event)->next = (yyvsp[(2) - (2)].event);    /* link new event to the end of the existing list */
	(yyval.event) = (yyvsp[(2) - (2)].event);          /* return the tail so that we can append to it */
}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 588 "parser.y"
    {
	(yyval.event) = (yyvsp[(2) - (2)].event);
	(yyval.event)->line_number = (yyvsp[(1) - (2)].event)->line_number;   /* use timestamp's line */
	(yyval.event)->time_usecs  = (yyvsp[(1) - (2)].event)->time_usecs;
	(yyval.event)->time_usecs_end  = (yyvsp[(1) - (2)].event)->time_usecs_end;
	(yyval.event)->time_type = (yyvsp[(1) - (2)].event)->time_type;

	if ((yyval.event)->time_usecs_end != NO_TIME_RANGE) {
		if ((yyval.event)->time_usecs_end < (yyval.event)->time_usecs)
			semantic_error("time range is backwards");
	}
	if ((yyval.event)->time_type == ANY_TIME &&  ((yyval.event)->type != PACKET_EVENT ||
	    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time <star> can only be used with "
			       "outbound packets");
	} else if (((yyval.event)->time_type == ABSOLUTE_RANGE_TIME ||
		    (yyval.event)->time_type == RELATIVE_RANGE_TIME) &&
	           ((yyval.event)->type != PACKET_EVENT ||
		    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time range can only be used with "
			       "outbound packets");
	}
	free((yyvsp[(1) - (2)].event));
}
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 617 "parser.y"
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[(2) - (2)]).first_line;
	(yyval.event)->time_usecs = (yyvsp[(2) - (2)].time_usecs);
	(yyval.event)->time_type = RELATIVE_TIME;
}
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 623 "parser.y"
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[(1) - (1)]).first_line;
	(yyval.event)->time_usecs = (yyvsp[(1) - (1)].time_usecs);
	(yyval.event)->time_type = ABSOLUTE_TIME;
}
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 629 "parser.y"
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[(1) - (1)]).first_line;
	(yyval.event)->time_type = ANY_TIME;
}
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 634 "parser.y"
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[(1) - (3)]).first_line;
	(yyval.event)->time_type = ABSOLUTE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[(1) - (3)].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[(3) - (3)].time_usecs);
}
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 641 "parser.y"
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[(1) - (5)]).first_line;
	(yyval.event)->time_type = RELATIVE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[(2) - (5)].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[(5) - (5)].time_usecs);
}
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 651 "parser.y"
    {
	if ((yyvsp[(1) - (1)].floating) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[(1) - (1)].floating) * 1.0e6); /* convert float secs to s64 microseconds */
}
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 657 "parser.y"
    {
	if ((yyvsp[(1) - (1)].integer) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[(1) - (1)].integer) * 1000000); /* convert int secs to s64 microseconds */
}
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 666 "parser.y"
    { (yyval.event) = new_event(PACKET_EVENT);  (yyval.event)->event.packet  = (yyvsp[(1) - (1)].packet); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 667 "parser.y"
    { (yyval.event) = new_event(SYSCALL_EVENT); (yyval.event)->event.syscall = (yyvsp[(1) - (1)].syscall); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 668 "parser.y"
    { (yyval.event) = new_event(COMMAND_EVENT); (yyval.event)->event.command = (yyvsp[(1) - (1)].command); }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 669 "parser.y"
    { (yyval.event) = new_event(CODE_EVENT);    (yyval.event)->event.code    = (yyvsp[(1) - (1)].code); }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 673 "parser.y"
    { (yyval.packet) = (yyvsp[(1) - (1)].packet); }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 674 "parser.y"
    { (yyval.packet) = (yyvsp[(1) - (1)].packet); }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 675 "parser.y"
    { (yyval.packet) = (yyvsp[(1) - (1)].packet); }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 679 "parser.y"
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[(1) - (7)].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (((yyvsp[(7) - (7)].tcp_options) == NULL) && (direction != DIRECTION_OUTBOUND)) {
		yylineno = (yylsp[(7) - (7)]).first_line;
		semantic_error("<...> for TCP options can only be used with "
			       "outbound packets");
	}

	inner = new_tcp_packet(in_config->wire_protocol,
			       direction, (yyvsp[(2) - (7)].ip_ecn), (yyvsp[(3) - (7)].string),
			       (yyvsp[(4) - (7)].tcp_sequence_info).start_sequence, (yyvsp[(4) - (7)].tcp_sequence_info).payload_bytes,
			       (yyvsp[(5) - (7)].sequence_number), (yyvsp[(6) - (7)].window), (yyvsp[(7) - (7)].tcp_options), &error);
	free((yyvsp[(3) - (7)].string));
	free((yyvsp[(7) - (7)].tcp_options));
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 707 "parser.y"
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[(1) - (5)].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (!is_valid_u16((yyvsp[(4) - (5)].integer))) {
		semantic_error("UDP payload size out of range");
	}

	inner = new_udp_packet(in_config->wire_protocol, direction, (yyvsp[(4) - (5)].integer), &error);
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 728 "parser.y"
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[(1) - (6)].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	inner = new_icmp_packet(in_config->wire_protocol, direction, (yyvsp[(4) - (6)].string), (yyvsp[(5) - (6)].string),
				(yyvsp[(2) - (6)].tcp_sequence_info).protocol, (yyvsp[(2) - (6)].tcp_sequence_info).start_sequence,
				(yyvsp[(2) - (6)].tcp_sequence_info).payload_bytes, (yyvsp[(6) - (6)].integer), &error);
	free((yyvsp[(4) - (6)].string));
	free((yyvsp[(5) - (6)].string));
	if (inner == NULL) {
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 749 "parser.y"
    {
	(yyval.packet) = packet_new(PACKET_MAX_HEADER_BYTES);
	(yyval.packet)->direction = (yyvsp[(1) - (1)].direction);
}
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 753 "parser.y"
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[(1) - (6)].packet);
	char *ip_src = (yyvsp[(3) - (6)].string);
	char *ip_dst = (yyvsp[(5) - (6)].string);
	if (ipv4_header_append(packet, ip_src, ip_dst, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 764 "parser.y"
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[(1) - (6)].packet);
	char *ip_src = (yyvsp[(3) - (6)].string);
	char *ip_dst = (yyvsp[(5) - (6)].string);
	if (ipv6_header_append(packet, ip_src, ip_dst, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 775 "parser.y"
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[(1) - (3)].packet);
	if (gre_header_append(packet, &error))
		semantic_error(error);
	(yyval.packet) = packet;
}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 782 "parser.y"
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[(1) - (4)].packet);
	struct mpls_stack *mpls_stack = (yyvsp[(3) - (4)].mpls_stack);

	if (mpls_header_append(packet, mpls_stack, &error))
		semantic_error(error);
	free(mpls_stack);
	(yyval.packet) = packet;
}
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 795 "parser.y"
    {
	(yyval.mpls_stack) = mpls_stack_new();
}
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 798 "parser.y"
    {
	if (mpls_stack_append((yyvsp[(1) - (2)].mpls_stack), (yyvsp[(2) - (2)].mpls_stack_entry)))
		semantic_error("too many MPLS labels");
	(yyval.mpls_stack) = (yyvsp[(1) - (2)].mpls_stack);
}
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 807 "parser.y"
    {
	char *error = NULL;
	s64 label = (yyvsp[(3) - (11)].integer);
	s64 traffic_class = (yyvsp[(6) - (11)].integer);
	bool is_stack_bottom = (yyvsp[(8) - (11)].integer);
	s64 ttl = (yyvsp[(10) - (11)].integer);
	struct mpls mpls;

	if (new_mpls_stack_entry(label, traffic_class, is_stack_bottom, ttl,
				 &mpls, &error))
		semantic_error(error);
	(yyval.mpls_stack_entry) = mpls;
}
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 823 "parser.y"
    { (yyval.integer) = 0; }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 824 "parser.y"
    {
	if (strcmp((yyvsp[(2) - (4)].string), "S") != 0)
		semantic_error("expected [S] for MPLS label stack bottom");
	free((yyvsp[(2) - (4)].string));
	(yyval.integer) = 1;
}
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 833 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 837 "parser.y"
    { (yyval.string) = NULL; }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 838 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 843 "parser.y"
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= 0;
	(yyval.tcp_sequence_info).protocol		= IPPROTO_TCP;
}
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 848 "parser.y"
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= (yyvsp[(4) - (6)].integer);
	(yyval.tcp_sequence_info).protocol		= IPPROTO_UDP;
}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 853 "parser.y"
    {
	(yyval.tcp_sequence_info) = (yyvsp[(2) - (3)].tcp_sequence_info);
}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 859 "parser.y"
    { (yyval.integer) = -1; }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 860 "parser.y"
    { (yyval.integer) = (yyvsp[(2) - (2)].integer); }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 864 "parser.y"
    { (yyval.direction) = DIRECTION_INBOUND;  current_script_line = yylineno; }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 865 "parser.y"
    { (yyval.direction) = DIRECTION_OUTBOUND; current_script_line = yylineno; }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 869 "parser.y"
    { (yyval.ip_ecn) = ECN_NOCHECK; }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 870 "parser.y"
    { (yyval.ip_ecn) = (yyvsp[(2) - (3)].ip_ecn); }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 874 "parser.y"
    { (yyval.ip_ecn) = ECN_NONE; }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 875 "parser.y"
    { (yyval.ip_ecn) = ECN_ECT0; }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 876 "parser.y"
    { (yyval.ip_ecn) = ECN_ECT1; }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 877 "parser.y"
    { (yyval.ip_ecn) = ECN_ECT01; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 878 "parser.y"
    { (yyval.ip_ecn) = ECN_CE; }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 882 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 883 "parser.y"
    { (yyval.string) = strdup("."); }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 884 "parser.y"
    { asprintf(&((yyval.string)), "%s.", (yyvsp[(1) - (2)].string)); free((yyvsp[(1) - (2)].string)); }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 885 "parser.y"
    { (yyval.string) = strdup(""); }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 889 "parser.y"
    {
	if (!is_valid_u32((yyvsp[(1) - (6)].integer))) {
		semantic_error("TCP start sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[(3) - (6)].integer))) {
		semantic_error("TCP end sequence number out of range");
	}
	if (!is_valid_u16((yyvsp[(5) - (6)].integer))) {
		semantic_error("TCP payload size out of range");
	}
	if ((yyvsp[(3) - (6)].integer) != ((yyvsp[(1) - (6)].integer) +(yyvsp[(5) - (6)].integer))) {
		semantic_error("inconsistent TCP sequence numbers and "
			       "payload size");
	}
	(yyval.tcp_sequence_info).start_sequence = (yyvsp[(1) - (6)].integer);
	(yyval.tcp_sequence_info).payload_bytes = (yyvsp[(5) - (6)].integer);
	(yyval.tcp_sequence_info).protocol = IPPROTO_TCP;
}
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 910 "parser.y"
    { (yyval.sequence_number) = 0; }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 911 "parser.y"
    {
	if (!is_valid_u32((yyvsp[(2) - (2)].integer))) {
		semantic_error("TCP ack sequence number out of range");
	}
	(yyval.sequence_number) = (yyvsp[(2) - (2)].integer);
}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 920 "parser.y"
    { (yyval.window) = -1; }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 921 "parser.y"
    {
	if (!is_valid_u16((yyvsp[(2) - (2)].integer))) {
		semantic_error("TCP window value out of range");
	}
	(yyval.window) = (yyvsp[(2) - (2)].integer);
}
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 930 "parser.y"
    { (yyval.tcp_options) = tcp_options_new(); }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 931 "parser.y"
    { (yyval.tcp_options) = (yyvsp[(2) - (3)].tcp_options); }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 932 "parser.y"
    { (yyval.tcp_options) = NULL; /* FLAG_OPTIONS_NOCHECK */ }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 936 "parser.y"
    {
	(yyval.tcp_options) = tcp_options_new();
	if (tcp_options_append((yyval.tcp_options), (yyvsp[(1) - (1)].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 942 "parser.y"
    {
	(yyval.tcp_options) = (yyvsp[(1) - (3)].tcp_options);
	if (tcp_options_append((yyval.tcp_options), (yyvsp[(3) - (3)].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 951 "parser.y"
    { (yyval.string) = strdup(""); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 952 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 956 "parser.y"
    { (yyval.string) = strdup(yytext); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 957 "parser.y"
    { (yyval.string) = strdup(yytext); }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 961 "parser.y"
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_NOP, 1); }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 962 "parser.y"
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_EOL, 1); }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 963 "parser.y"
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_MAXSEG, TCPOLEN_MAXSEG);
	if (!is_valid_u16((yyvsp[(2) - (2)].integer))) {
		semantic_error("mss value out of range");
	}
	(yyval.tcp_option)->data.mss.bytes = htons((yyvsp[(2) - (2)].integer));
}
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 970 "parser.y"
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_WINDOW, TCPOLEN_WINDOW);
	if (!is_valid_u8((yyvsp[(2) - (2)].integer))) {
		semantic_error("window scale shift count out of range");
	}
	(yyval.tcp_option)->data.window_scale.shift_count = (yyvsp[(2) - (2)].integer);
}
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 977 "parser.y"
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK_PERMITTED,
				    TCPOLEN_SACK_PERMITTED);
}
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 981 "parser.y"
    {
	(yyval.tcp_option) = (yyvsp[(2) - (2)].tcp_option);
}
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 984 "parser.y"
    {
	u32 val, ecr;
	(yyval.tcp_option) = tcp_option_new(TCPOPT_TIMESTAMP, TCPOLEN_TIMESTAMP);
	if (!is_valid_u32((yyvsp[(3) - (5)].integer))) {
		semantic_error("ts val out of range");
	}
	if (!is_valid_u32((yyvsp[(5) - (5)].integer))) {
		semantic_error("ecr val out of range");
	}
	val = (yyvsp[(3) - (5)].integer);
	ecr = (yyvsp[(5) - (5)].integer);
	(yyval.tcp_option)->data.time_stamp.val = htonl(val);
	(yyval.tcp_option)->data.time_stamp.ecr = htonl(ecr);
}
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 998 "parser.y"
    {
	char *error = NULL;
	(yyval.tcp_option) = new_tcp_fast_open_option((yyvsp[(2) - (2)].string), &error);
	free((yyvsp[(2) - (2)].string));
	if ((yyval.tcp_option) == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}
}
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1011 "parser.y"
    { (yyval.tcp_option) = (yyvsp[(1) - (1)].tcp_option); }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1012 "parser.y"
    {
	const int list_block_bytes =  (yyvsp[(1) - (2)].tcp_option)->length - 2;
	assert(list_block_bytes > 0);
	assert((list_block_bytes % sizeof(struct sack_block)) == 0);
	const int num_blocks = list_block_bytes / sizeof(struct sack_block);
	/* Append this SACK block to the end of the array of blocks. */
	memcpy((yyvsp[(1) - (2)].tcp_option)->data.sack.block + num_blocks, (yyvsp[(2) - (2)].tcp_option)->data.sack.block,
		sizeof(struct sack_block));
	(yyvsp[(1) - (2)].tcp_option)->length += sizeof(struct sack_block);
	free((yyvsp[(2) - (2)].tcp_option));
	(yyval.tcp_option) = (yyvsp[(1) - (2)].tcp_option);
}
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1027 "parser.y"
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK, 2 + sizeof(struct sack_block));
	if (!is_valid_u32((yyvsp[(1) - (3)].integer))) {
		semantic_error("TCP SACK left sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[(3) - (3)].integer))) {
		semantic_error("TCP SACK right sequence number out of range");
	}
	(yyval.tcp_option)->data.sack.block[0].left = htonl((yyvsp[(1) - (3)].integer));
	(yyval.tcp_option)->data.sack.block[0].right = htonl((yyvsp[(3) - (3)].integer));
}
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1042 "parser.y"
    {
	(yyval.syscall) = calloc(1, sizeof(struct syscall_spec));
	(yyval.syscall)->end_usecs	= (yyvsp[(1) - (7)].time_usecs);
	(yyval.syscall)->name	= (yyvsp[(2) - (7)].string);
	(yyval.syscall)->arguments	= (yyvsp[(3) - (7)].expression_list);
	(yyval.syscall)->result	= (yyvsp[(5) - (7)].expression);
	(yyval.syscall)->error	= (yyvsp[(6) - (7)].errno_info);
	(yyval.syscall)->note	= (yyvsp[(7) - (7)].string);
}
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1054 "parser.y"
    { (yyval.time_usecs) = SYSCALL_NON_BLOCKING; }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1055 "parser.y"
    { (yyval.time_usecs) = (yyvsp[(2) - (2)].time_usecs); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1059 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); current_script_line = yylineno; }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1063 "parser.y"
    { (yyval.expression_list) = NULL; }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1064 "parser.y"
    { (yyval.expression_list) = (yyvsp[(2) - (3)].expression_list); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1068 "parser.y"
    { (yyval.expression_list) = new_expression_list((yyvsp[(1) - (1)].expression)); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1069 "parser.y"
    { (yyval.expression_list) = (yyvsp[(1) - (3)].expression_list); expression_list_append((yyvsp[(1) - (3)].expression_list), (yyvsp[(3) - (3)].expression)); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1073 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_ELLIPSIS);
}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1076 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1077 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1078 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_WORD);
	(yyval.expression)->value.string = (yyvsp[(1) - (1)].string);
}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1082 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.string = (yyvsp[(1) - (1)].string);
	(yyval.expression)->format = "\"%s\"";
}
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1087 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.string = (yyvsp[(1) - (2)].string);
	(yyval.expression)->format = "\"%s\"...";
}
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1092 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1095 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1098 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1101 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1104 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1107 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1110 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1113 "parser.y"
    {
	(yyval.expression) = (yyvsp[(1) - (1)].expression);
}
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1119 "parser.y"
    {
	(yyval.expression) = new_integer_expression((yyvsp[(1) - (1)].integer), "%ld");
}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1125 "parser.y"
    {
	(yyval.expression) = new_integer_expression((yyvsp[(1) - (1)].integer), "%#lx");
}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1131 "parser.y"
    {       /* bitwise OR */
	(yyval.expression) = new_expression(EXPR_BINARY);
	struct binary_expression *binary =
			  malloc(sizeof(struct binary_expression));
	binary->op = strdup("|");
	binary->lhs = (yyvsp[(1) - (3)].expression);
	binary->rhs = (yyvsp[(3) - (3)].expression);
	(yyval.expression)->value.binary = binary;
}
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1143 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = NULL;
}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1147 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = (yyvsp[(2) - (3)].expression_list);
}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1154 "parser.y"
    {
	__be32 ip_address = inet_addr((yyvsp[(3) - (4)].string));
	(yyval.expression) = new_integer_expression(ip_address, "%#lx");
}
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1163 "parser.y"
    {
	if (strcmp((yyvsp[(4) - (19)].string), "AF_INET") == 0) {
		struct sockaddr_in *ipv4 = malloc(sizeof(struct sockaddr_in));
		memset(ipv4, 0, sizeof(*ipv4));
		ipv4->sin_family = AF_INET;
		ipv4->sin_port = htons((yyvsp[(10) - (19)].integer));
		if (inet_pton(AF_INET, (yyvsp[(17) - (19)].string), &ipv4->sin_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV4);
			(yyval.expression)->value.socket_address_ipv4 = ipv4;
		} else {
			free(ipv4);
			semantic_error("invalid IPv4 address");
		}
	} else if (strcmp((yyvsp[(4) - (19)].string), "AF_INET6") == 0) {
		struct sockaddr_in6 *ipv6 = malloc(sizeof(struct sockaddr_in6));
		memset(ipv6, 0, sizeof(*ipv6));
		ipv6->sin6_family = AF_INET6;
		ipv6->sin6_port = htons((yyvsp[(10) - (19)].integer));
		if (inet_pton(AF_INET6, (yyvsp[(17) - (19)].string), &ipv6->sin6_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV6);
			(yyval.expression)->value.socket_address_ipv6 = ipv6;
		} else {
			free(ipv6);
			semantic_error("invalid IPv6 address");
		}
	}
}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1195 "parser.y"
    {
	struct msghdr_expr *msg_expr = calloc(1, sizeof(struct msghdr_expr));
	(yyval.expression) = new_expression(EXPR_MSGHDR);
	(yyval.expression)->value.msghdr = msg_expr;
	msg_expr->msg_name	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_namelen	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_iov	= (yyvsp[(14) - (19)].expression);
	msg_expr->msg_iovlen	= (yyvsp[(11) - (19)].expression);
	msg_expr->msg_flags	= (yyvsp[(18) - (19)].expression);
	/* TODO(ncardwell): msg_control, msg_controllen */
}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1209 "parser.y"
    {
	struct iovec_expr *iov_expr = calloc(1, sizeof(struct iovec_expr));
	(yyval.expression) = new_expression(EXPR_IOVEC);
	(yyval.expression)->value.iovec = iov_expr;
	iov_expr->iov_base = new_expression(EXPR_ELLIPSIS);
	iov_expr->iov_len = (yyvsp[(4) - (5)].expression);
}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 1219 "parser.y"
    {
	struct pollfd_expr *pollfd_expr = calloc(1, sizeof(struct pollfd_expr));
	(yyval.expression) = new_expression(EXPR_POLLFD);
	(yyval.expression)->value.pollfd = pollfd_expr;
	pollfd_expr->fd = (yyvsp[(4) - (10)].expression);
	pollfd_expr->events = (yyvsp[(8) - (10)].expression);
	pollfd_expr->revents = (yyvsp[(9) - (10)].expression);
}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 1230 "parser.y"
    { (yyval.expression) = new_integer_expression(0, "%ld"); }
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 1231 "parser.y"
    { (yyval.expression) = (yyvsp[(4) - (4)].expression); }
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 1235 "parser.y"
    {
	(yyval.expression) = new_expression(EXPR_LINGER);
	(yyval.expression)->value.linger.l_onoff  = (yyvsp[(4) - (9)].integer);
	(yyval.expression)->value.linger.l_linger = (yyvsp[(8) - (9)].integer);
}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 1243 "parser.y"
    { (yyval.errno_info) = NULL; }
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 1244 "parser.y"
    {
	(yyval.errno_info) = malloc(sizeof(struct errno_spec));
	(yyval.errno_info)->errno_macro = (yyvsp[(1) - (2)].string);
	(yyval.errno_info)->strerror    = (yyvsp[(2) - (2)].string);
}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 1252 "parser.y"
    { (yyval.string) = NULL; }
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 1253 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 1257 "parser.y"
    { (yyval.string) = (yyvsp[(2) - (3)].string); }
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 1261 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 1262 "parser.y"
    { asprintf(&((yyval.string)), "%s %s", (yyvsp[(1) - (2)].string), (yyvsp[(2) - (2)].string)); free((yyvsp[(1) - (2)].string)); free((yyvsp[(2) - (2)].string)); }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 1266 "parser.y"
    {
	(yyval.command) = malloc(sizeof(struct command_spec));
	(yyval.command)->command_line = (yyvsp[(1) - (1)].string);
	current_script_line = yylineno;
}
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 1274 "parser.y"
    {
	(yyval.code) = calloc(1, sizeof(struct code_spec));
	(yyval.code)->text = (yyvsp[(1) - (1)].string);
	current_script_line = yylineno;
 }
    break;


/* Line 1792 of yacc.c  */
#line 3480 "parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


